=== build/Makefile ===
T=all install clean util cons reg db sdb libr binr shlr
.PHONY: ${T}
${T}:
	@node radare2.js $@
