=== pkgcfg/Makefile ===
all:
	cd ../libr && ${MAKE} pkgcfg
