=== binr/r2agent/Makefile ===
BIN=r2agent
BINDEPS=r_socket r_cons r_util

include ../rules.mk
