=== debian/changelog ===
radare2 (0.9.6-3.1ubuntu1) trusty; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use autotools-dev to update config.{sub,guess} for new arches.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 10 Apr 2014 12:38:27 -0400

radare2 (0.9.6-3.1) unstable; urgency=medium

  * debian/patches/12_fix_strcasestr_declaration: Add #define _GNU_SOURCE
    as well, to get the definition of strcasestr (closes: #735921).

 -- Steve McIntyre <93sam@debian.org>  Sun, 23 Mar 2014 14:38:44 +0000

radare2 (0.9.6-3ubuntu1) trusty; urgency=low

  * Use autotools-dev helper for newer arches.
  * Define missing macro so the strcasestr fix is actually used.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 31 Mar 2014 15:26:56 -0400

radare2 (0.9.6-3) unstable; urgency=medium

  * debian/patches/12_fix_strcasestr_declaration: Fixed a missing include,
    thanks to Matthias Klose for pointing it (closes: #735921).

 -- David Martínez Moreno <ender@debian.org>  Tue, 28 Jan 2014 10:29:31 -0800

radare2 (0.9.6-2) unstable; urgency=low

  * debian/control: Switched Sebastian and myself as Maintainer/Uploader.
  * debian/patches/08_proper_tcc_build: Updated to fix a wrong ifeq in the
    Makefile.
  * debian/watch: Updated as it seems that pancake is releasing .tar.xz now.
  * debian/patches/01_fix-kfreebsd-compilation: Completely revamped from
    upstream commit 1941efc, to (hopefully) fix builds on kFreeBSD.
  * Added a lintian override for spelling-error-in-binary in libradare2-0.9.6,
    as it's invalid.

 -- David Martínez Moreno <ender@debian.org>  Fri, 17 Jan 2014 07:48:47 -0800

radare2 (0.9.6-1) unstable; urgency=low

  * New Year's release.  Just in time!
  * New upstream release.  Main changes are:
    - r2 now supports UTF-8, RGB and TrueColor ansi codes.
    - More platforms supported: ARM aarch64, TI c55x+, 8051, Javascript
      (emscripten), ARCcompact.
    - ASLR for PIE binaries is now supported by using the -B flag.
    - MACH0 XNU kernels are now properly loaded.
    - Added support for TE binaries.
    - Identify some PC BIOS and UEFI ROMs.
    - Java Class file parser has been rewritten to support Java7.
    - Python ctypes, D and Java JNI bindings.
    - An embedded webserver have been included, and you can invoke it using
      the `=h' or '=H' commands.
    - Improved JSON output for many commands. Just append 'j' to the command
      and it will use that format.
    - First release with an extensive test suite.
    - Lots of bugs has been fixed, overflows, memory leaks, and many
      handcrafted binaries can now be loaded without segfaults, crashes or
      lack of info (closes: #716192).
  * debian/patches:
    - 01_fix-kfreebsd-compilation: Refreshed.
    - 02_link-needed-libmagic: Fixed.
    - 03_unsafe_snprintf: New, partly taken from upstream commit 1289476 to
      fix an incomplete snprintf that was breaking the hardened build.
    - 04_remove_non-installable_library: New, to fix an extraneous t.0.9.6
      that was appearing in the builds.
    - 05_typos: Added, some typos and wrong man macros.
    - 06_no_forced_rpath: Added, disable rpath when --with-rpath is not
      present.
    - 07_propagate_ldflags: New, propagate LDFLAGS from environment into
      compilation by making assignment additive, fixing hardened builds.
    - 08_proper_tcc_build: Add .so as the default suffix of libr_tcc.
    - 09_fix_internal_plugins: New, fixed a bunch of problems with the
      internal bindings: made the lua check support Debian's lua, fixed
      library prefix, and removed ncurses bogus linking.
    - 10_fix_rafind2_segfault: New, backported from e0f4364 to fix a segfault
      reported by the Mayhem team (closes: #716503).
    - 11_block_libtcc_install: New, backported from upstream 1531e96 to stop
      installing libtcc files.
    - 101_split_plugins_installation: New, Debian-only, to ease packaging of
      the plugins.  Otherwise they ended up in libradare2.
  * debian/control:
    - Build-Depends on valabind (>> 0.7.4) and swig to generate internal
      plugins, plus python-dev and liblua5.2-dev for the corresponding
      extensions, and dh-exec to help with the packaging of radare2-plugins.
    - Updated descriptions.
    - Bumped Standards-Version to 3.9.5 (no changes).
    - Created another package (radare2-plugins) with the Python and Lua
      extensions (plus the dependency on Vala).
    - Make radare-plugins depend on valac; otherwise the vala extension is not
      functional.
  * debian/rules:
    - Fix a broken flag for configure (--without-debugger ->
      --disable-debugger) that was causing the debugger to be enabled back in
      several architectures where it was previously disabled, and thus breaking
      the builds (closes: #732853).
    - Force --fail-missing on dh_install to make sure that we don't miss new
      files in subsequent releases.
  * Removed the libradare2's symbols file because radare2 doesn't really try
    to have any sort of backwards compatibility.  It's futile to dump it from
    scratch in every release.

 -- David Martínez Moreno <ender@debian.org>  Tue, 31 Dec 2013 23:57:03 -0800

radare2 (0.9.4-2) unstable; urgency=low

  [ Sebastian Reichel ]
  * r_debug_desc_plugin_native is not available on some architectures,
    so make tag it accordingly in *.symbols file.
  * Add patch to fix compilation under GNU/kFreeBSD.

 -- David Martínez Moreno <ender@debian.org>  Tue, 10 Dec 2013 11:17:44 -0800

radare2 (0.9.4-1) unstable; urgency=low

  * New upstream release
  * Update debian/copyright
  * Bump Debian Standards Version 3.9.2 -> 3.9.4
  * Create new -common package for arch independent files

 -- Sebastian Reichel <sre@debian.org>  Sun, 22 Sep 2013 19:50:24 +0200
