=== debian/watch ===
version=3
http://radare.org/get/radare2-([\d\.]+)\.tar\.xz
